UrzUI = UrzUI or CreateFrame("Frame", "UrzUI");
UrzBuffIcon = UrzBuffIcon or CreateFrame("Frame", "UrzBuffIcon");
UrzAbsorbLabel = UrzAbsorbLabel or PlayerFrame:CreateFontString("UrzAbsorbLabel");
UrzAbsorb = UrzAbsorb or PlayerFrame:CreateFontString("UrzAbsorb");
UrzPowerLabel = UrzPowerLabel or MainMenuBar:CreateFontString("UrzPowerLabel");
UrzPower = UrzPower or MainMenuBar:CreateFontString("UrzPower");
UrzHasteLabel = UrzHasteLabel or MainMenuBar:CreateFontString("UrzHasteLabel");
UrzHaste = UrzHaste or MainMenuBar:CreateFontString("UrzHaste");
UrzCritLabel = UrzCritLabel or MainMenuBar:CreateFontString("UrzCritLabel");
UrzCrit = UrzCrit or MainMenuBar:CreateFontString("UrzCrit");
UrzMasteryLabel = UrzMasteryLabel or MainMenuBar:CreateFontString("UrzMasteryLabel");
UrzMastery = UrzMastery or MainMenuBar:CreateFontString("UrzMastery");

local function SetActionBars()
   for _, value in pairs({"MainMenuBarPageNumber", "ActionBarUpButton", "ActionBarDownButton", "MainMenuBarLeftEndCap", "MainMenuBarRightEndCap", "MainMenuXPBarTextureLeftCap", "MainMenuXPBarTextureMid", "MainMenuXPBarTextureRightCap", "StanceBarLeft", "StanceBarMiddle", "StanceBarRight", "SlidingActionBarTexture0", "SlidingActionBarTexture1", "PossessBackground1", "PossessBackground2", "OverrideActionBarEndCapL", "OverrideActionBarEndCapR", "MainMenuXPBarDiv1", "MainMenuXPBarDiv2", "MainMenuXPBarDiv3", "MainMenuXPBarDiv4", "MainMenuXPBarDiv5", "MainMenuXPBarDiv6", "MainMenuXPBarDiv7", "MainMenuXPBarDiv8", "MainMenuXPBarDiv9", "MainMenuXPBarDiv10", "MainMenuXPBarDiv11", "MainMenuXPBarDiv12", "MainMenuXPBarDiv13", "MainMenuXPBarDiv14", "MainMenuXPBarDiv15", "MainMenuXPBarDiv16", "MainMenuXPBarDiv17", "MainMenuXPBarDiv18", "MainMenuXPBarDiv19", "MainMenuBarTexture0", "MainMenuBarTexture1", "MainMenuBarTexture2", "MainMenuBarTexture3", "ReputationXPBarTexture0", "ReputationXPBarTexture1", "ReputationXPBarTexture2", "ReputationXPBarTexture3", "ReputationWatchBarTexture0", "ReputationWatchBarTexture1", "ReputationWatchBarTexture2", "ReputationWatchBarTexture3", "MainMenuMaxLevelBar0", "MainMenuMaxLevelBar1", "MainMenuMaxLevelBar2", "MainMenuMaxLevelBar3", "UIErrorsFrame"}) do
      local name = _G[value];
      if ( name ) then
         if ( name:GetObjectType() == "Texture" ) then
            name:SetTexture(nil);
         end
         name:SetAlpha(0);
         name:Hide();
      end
   end
   for _, value in pairs({"StanceBarFrame", "PossessBarFrame", "PetActionBarFrame", "MultiBarLeft", "MultiBarRight", "MultiBarBottomLeft", "MultiBarBottomRight", "MainMenuBar", "MainMenuBarMaxLevelBar", "UIErrorsFrame"}) do
      local name = _G[value];
      if ( name ) then
         name:SetFrameStrata("MEDIUM");
         name:EnableMouse(false);
      end
   end
   for _, value in pairs({"ActionButton", "MultiBarBottomLeftButton", "MultiBarBottomRightButton", "MultiBarLeftButton", "MultiBarRightButton", "StanceButton", "PetActionButton", "PossessButton"}) do
      for i = 1, 12 do
         local name = _G[value..i];
         if ( name ) then
            name:GetNormalTexture():SetPoint("TOPLEFT", name, "TOPLEFT", -12, 12);
            name:GetNormalTexture():SetPoint("BOTTOMRIGHT", name, "BOTTOMRIGHT", 13, -13);
            name:SetSize(36, 36);
            name:SetScale(1);
            for _, value2 in pairs({"FloatingBG", "Name"}) do
               local name2 = _G[name:GetName()..value2];
               if ( name2 ) then
                  name2:SetAlpha(0);
               end
            end
         end
      end
   end
   MainMenuBarVehicleLeaveButton:SetSize(36, 36);
   MainMenuBarVehicleLeaveButton:SetScale(0.7);
   StanceBarFrame:SetScale(0.7);
   PossessBarFrame:SetScale(0.7);
   PetActionBarFrame:SetScale(0.7);
   OverrideActionBar:SetScale(0.7);
   PetBattleFrame:SetScale(0.7);
   MainMenuBar:SetWidth(512);
   MultiBarBottomLeftButton1:ClearAllPoints();
   MultiBarBottomLeftButton1:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 6);
   MultiBarBottomRightButton1:ClearAllPoints();
   MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton1, "TOPLEFT", 0, 6);
   StanceButton1:ClearAllPoints();
   StanceButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
   PossessButton1:ClearAllPoints();
   PossessButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
   PetActionButton10:ClearAllPoints();
   PetActionButton10:SetPoint("BOTTOMRIGHT", MultiBarBottomRightButton12, "TOPRIGHT", 0, 6);
   PossessButton2:ClearAllPoints();
   PossessButton2:SetPoint("LEFT",  PossessButton1, "RIGHT", 6, 0);
   for i = 1, 9 do
      _G["StanceButton"..i+1]:ClearAllPoints();
      _G["StanceButton"..i+1]:SetPoint("LEFT", _G["StanceButton"..i], "RIGHT", 6, 0);
      _G["PetActionButton"..10-i]:ClearAllPoints();
      _G["PetActionButton"..10-i]:SetPoint("RIGHT", _G["PetActionButton"..11-i], "LEFT", -6, 0);
   end
   hooksecurefunc("MainMenuBarVehicleLeaveButton_Update", function()
         MainMenuBarVehicleLeaveButton:ClearAllPoints();
         if ( IsPossessBarVisible() ) then
            MainMenuBarVehicleLeaveButton:SetPoint("LEFT", PossessButton2, "RIGHT", 30, 0);
         elseif ( GetNumShapeshiftForms() > 0 ) then
            MainMenuBarVehicleLeaveButton:SetPoint("LEFT", "StanceButton"..GetNumShapeshiftForms(), "RIGHT", 30, 0);
         else
            MainMenuBarVehicleLeaveButton:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
         end
   end);
   CharacterMicroButton:ClearAllPoints();
   CharacterMicroButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -275, 1);
   PVPMicroButton:ClearAllPoints();
   PVPMicroButton:SetPoint("BOTTOMLEFT", GuildMicroButton, "BOTTOMRIGHT", -3, 0);
   MainMenuBar:SetScript("OnShow", function(self)
         UpdateMicroButtonsParent(MainMenuBarArtFrame);
         CharacterMicroButton:ClearAllPoints();
         CharacterMicroButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -275, 1);
         PVPMicroButton:ClearAllPoints();
         PVPMicroButton:SetPoint("BOTTOMLEFT", GuildMicroButton, "BOTTOMRIGHT", -3, 0);
   end);
   CompactUnitFrameProfilesGeneralOptionsFrameHeightSlider:SetMinMaxValues(20, 40);
end

local function SetChatFrames()
   DEFAULT_CHATFRAME_ALPHA = 0;
   CHAT_FRAME_TAB_ALERTING_MOUSEOVER_ALPHA = 0.5;
   CHAT_FRAME_TAB_ALERTING_NOMOUSE_ALPHA = 0.5;
   CHAT_FRAME_TAB_NORMAL_MOUSEOVER_ALPHA = 0.5;
   CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0.5;
   CHAT_FRAME_TAB_SELECTED_MOUSEOVER_ALPHA = 1;
   CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 1;
   FCF_UnDockFrame(ChatFrame2);
   FCF_SetTabPosition(ChatFrame2, 0);
   for i = 1, NUM_CHAT_WINDOWS do
      local cf = _G["ChatFrame"..i];
      if ( cf ) then
         FCF_SetChatWindowFontSize(nil, cf, 16);
         cf:SetClampRectInsets(0, 0, 0, 0);
         FCF_SetLocked(cf, false);
         FCF_SetUninteractable(cf, false);
         FCF_SetLocked(cf, true);
         for _, value in pairs({"Left", "Middle", "Right", "SelectedLeft", "SelectedMiddle", "SelectedRight", "HighlightLeft", "HighlightMiddle", "HighlightRight"}) do
            local name = _G["ChatFrame"..i.."Tab"..value];
            if ( name ) then
               name:SetAlpha(0);
            end
         end
         FCF_SetWindowAlpha(cf, DEFAULT_CHATFRAME_ALPHA);
         FCFTab_UpdateAlpha(cf);
      end
   end
   FCF_SetChatWindowFontSize(nil, ChatFrame2, 12);
   CombatLogQuickButtonFrame_Custom:SetHeight(0);
   CombatLogQuickButtonFrame_Custom:Hide();
   ChatFrame2:HookScript("OnShow", function(self)
         CombatLogQuickButtonFrame_Custom:SetHeight(0);
         CombatLogQuickButtonFrame_Custom:Hide();
   end);
   ChatFrame2ButtonFrameMinimizeButton:Hide();
   ChatFrame1:SetSize(GetScreenWidth()/2-298, 115);
   ChatFrame1:ClearAllPoints();
   ChatFrame1:SetPoint("BOTTOMLEFT", UIParent, 35, 35);
   ChatFrame2:SetSize(ChatFrame1:GetWidth(), 65);
   ChatFrame2:ClearAllPoints();
   ChatFrame2:SetPoint("BOTTOMLEFT", ChatFrame1, "TOPLEFT", 0, 44);
   ChatFrame2EditBox:SetAllPoints(ChatFrame1EditBox);
   FCF_SavePositionAndDimensions(ChatFrame1);
   FCF_SavePositionAndDimensions(ChatFrame2);
   FloatingChatFrame_Update(1);
   FloatingChatFrame_Update(2);
   FCFManager_RegisterDedicatedFrame(ChatFrame2, "PET_BATTLE_COMBAT_LOG");
   FCF_FadeOutChatFrame(ChatFrame2);
   for value in pairs(ChatTypeGroup) do
      if ( value ) then
         SetChatColorNameByClass(value, true);
      end
   end
   for i = 1, MAX_WOW_CHAT_CHANNELS do
      local name = "CHANNEL"..i;
      if ( name ) then
         SetChatColorNameByClass(name, true);
      end
   end
end

local function SetMicroMenu()
   MainMenuExpBar:SetSize(300, 13);
   ReputationWatchStatusBar:SetSize(300, 13);
   ReputationWatchBar:SetSize(300, 13);
   ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, "CENTER", 0, 1);
   ReputationWatchBarOverlayFrame:SetFrameStrata("MEDIUM");
   local y = 40;
   MainMenuExpBar:ClearAllPoints();
   MainMenuExpBar:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
   if ( MainMenuExpBar:IsShown() ) then
      y = y+16;
   end
   ReputationWatchBar:ClearAllPoints();
   ReputationWatchBar:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
   if ( ReputationWatchBar:IsShown() ) then
      y = y+16;
   end
   MainMenuBarBackpackButton:ClearAllPoints();
   MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
end

local function SetStats()
   for _, value in pairs({"UrzAbsorb", "UrzPower", "UrzHaste", "UrzCrit", "UrzMastery"}) do
      local stat = _G[value];
      if ( stat and stat:GetObjectType() == "FontString" ) then
         stat:ClearAllPoints();
         stat:SetFont(STANDARD_TEXT_FONT, 10, "THINOUTLINE");
         stat:SetJustifyH("LEFT");
         stat:SetJustifyV("MIDDLE");
         stat:SetText(nil);
         stat:Show();
      end
      local name = _G[value.."Label"];
      if ( name and name:GetObjectType() == "FontString" ) then
         name:ClearAllPoints();
         name:SetPoint("BOTTOMLEFT", stat, "TOPLEFT", 0, 2);
         name:SetFont(STANDARD_TEXT_FONT, 10);
         name:SetTextColor(1, 1, 1, 0.8);
         name:SetShadowColor(0, 0, 0, 0.8);
         name:SetShadowOffset(1,-1);
         name:SetJustifyH("LEFT");
         name:SetJustifyV("MIDDLE");
         name:Show();
      end
   end
   UrzAbsorbLabel:SetText("Absorb");
   UrzPowerLabel:SetText("Power");
   UrzHasteLabel:SetText("Haste");
   UrzCritLabel:SetText("Crit");
   UrzMasteryLabel:SetText("Mastery");
   UrzPower:SetFont(STANDARD_TEXT_FONT, 20, "THINOUTLINE");
   UrzAbsorb:SetPoint("LEFT", PlayerFrameHealthBar, "RIGHT", 6, 0);
   UrzHaste:SetPoint("BOTTOMLEFT", UrzCritLabel, "TOPLEFT", 0, 2);
   UrzCrit:SetPoint("BOTTOMLEFT", UrzMasteryLabel, "TOPLEFT", 0, 2);
   UrzMastery:SetPoint("BOTTOMLEFT", StanceButton1, "TOPLEFT", 0, 6);
   UrzPower:SetPoint("BOTTOMLEFT", StanceButton1, "TOPLEFT", 55, 3);
   UrzBuffIcon:SetSize(72, 72);
   UrzBuffIcon:SetBackdrop({bgFile = "Interface\\Icons\\ABILITY_HUNTER_FOCUSEDAIM", edgeFile = nil, tile = false, tileSize = 36, edgeSize = 0, insets = {left = 0, right = 0, top = 0, bottom = 0}});
   UrzBuffIcon:ClearAllPoints();
   UrzBuffIcon:SetPoint("BOTTOMLEFT", UrzPowerLabel, "TOPLEFT", 0, 2);
   UrzBuffIcon:Hide();
end

local function SetTargetHealth(textStatusBar)
   if ( textStatusBar == TargetFrameHealthBar ) then
      local health = UnitHealth("target");
      if ( health > 0 ) then
         TargetFrameTextureFrameHealthBarText:SetText(string.format("%s%s%d%s", AbbreviateLargeNumbers(health), "   ", math.ceil(health/UnitHealthMax("target")*100), "%"));
      end
   end
end

local function GetAbsorb()
   local stat = UnitGetTotalAbsorbs("player") or 0;
   if ( stat >= 1000000 ) then
      stat = floor(stat/1000000)..SECOND_NUMBER_CAP;
   elseif ( stat >= 1000 ) then
      stat = floor(stat/1000)..FIRST_NUMBER_CAP;
   else
      stat = floor(stat);
   end
   return stat;
end

local function GetPower()
   local stat = GetSpellBonusDamage(1);
   local base, buff, debuff, bonus;
   for i = 2, MAX_SPELL_SCHOOLS do
      bonus = GetSpellBonusDamage(i);
      stat = min(stat, bonus);
   end
   bonus = GetSpellBonusHealing();
   stat = max(stat, bonus);
   base, buff, debuff = UnitAttackPower("player");
   bonus = base+buff+debuff;
   stat = max(stat, bonus);
   base, buff, debuff = UnitRangedAttackPower("player");
   bonus = base+buff+debuff;
   stat = max(stat, bonus);
   if ( stat >= 1000000 ) then
      stat = floor(stat/1000000)..SECOND_NUMBER_CAP;
   elseif ( stat >= 1000 ) then
      stat = floor(stat/1000)..FIRST_NUMBER_CAP;
   else
      stat = floor(stat);
   end
   return stat;
end

function GetCrit()
   local stat = GetSpellCritChance(1);
   local bonus;
   for i = 2, MAX_SPELL_SCHOOLS do
      bonus = GetSpellCritChance(i);
      stat = min(stat, bonus);
   end
   stat = floor(max(stat, GetCritChance(), GetRangedCritChance()));
   if ( stat >= 100 ) then
      UrzBuffIcon:Show();
   else
      UrzBuffIcon:Hide();
   end
   return stat;
end

local function UpdateHandler(self, elapsed)
   for i = 1, WorldFrame:GetNumChildren() do
      local frame = select(i, WorldFrame:GetChildren());
      if ( frame:GetName() and frame:GetName():match("NamePlate") ) then
         local plate, name = frame:GetChildren();
         local threat, bg, _, lvl = plate:GetRegions();
         local font = name:GetRegions();
         if ( bg:GetAlpha() > 0 ) then
            bg:SetAlpha(0);
            font:SetFont("Fonts\\ARIALN.TTF", 12, nil);
            font:SetShadowOffset(1, -1);
            lvl:SetFont("Fonts\\ARIALN.TTF", 12, nil);
            lvl:SetShadowOffset(1, -1);
         end
         if ( threat:IsShown() ) then
            font:SetTextColor(1, 0.3, 0, 1);
         else
            font:SetTextColor(1, 1, 1, 1);
         end
         if ( UnitExists("target") and frame:GetAlpha() == 1 ) then
            threat:SetVertexColor(1, 1, 1, 1);
            threat:Show();
         else
            threat:Hide();
         end
         frame:SetAlpha(1);
      end
   end
   UrzAbsorb:SetText(GetAbsorb());
   UrzPower:SetText(GetPower());
   UrzHaste:SetText(floor(max(UnitSpellHaste("player"), GetRangedHaste("player"), GetMeleeHaste("player"))).." %");
   UrzCrit:SetText(GetCrit().." %");
   UrzMastery:SetText(floor(GetMasteryEffect()).." %");
end

local function EventHandler(self, event, ...)
   if ( event == "MERCHANT_SHOW" ) then
      for bag = 0, 4 do
         for slot = 0, GetContainerNumSlots(bag) do
            local link = GetContainerItemLink(bag, slot);
            if ( link and (select(3, GetItemInfo(link)) == 0) ) then
               UseContainerItem(bag, slot);
            end
         end
      end
      RepairAllItems(1);
   elseif ( event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_REGEN_ENABLED" ) then
      if ( not UnitAffectingCombat("player") ) then
         UrzUI:UnregisterEvent("PLAYER_ENTERING_WORLD");
         UrzUI:UnregisterEvent("PLAYER_REGEN_ENABLED");
         SetActionBars();
         SetChatFrames();
         SetMicroMenu();
         SetStats();
         hooksecurefunc("ReputationWatchBar_Update", SetMicroMenu);
         hooksecurefunc("TextStatusBar_UpdateTextString", SetTargetHealth);
         UrzUI:SetScript("OnUpdate", UpdateHandler);
      end
   end
end

UrzUI:SetScript("OnEvent", EventHandler);
UrzUI:RegisterEvent("PLAYER_ENTERING_WORLD");
UrzUI:RegisterEvent("PLAYER_REGEN_ENABLED");
UrzUI:RegisterEvent("MERCHANT_SHOW");
